import { CommonModule } from '@angular/common';
import { setTheme } from 'ngx-bootstrap/utils';
import { __extends, __awaiter, __generator, __decorate, __metadata, __read } from 'tslib';
import { Component, HostBinding, NgModule } from '@angular/core';
import { BaseUIComponent, ContainerProperties, propDescription, CoreService, CoreModule } from '@ngx-dynamic-components/core';

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var ContainerComponent = /** @class */ (function (_super) {
    __extends(ContainerComponent, _super);
    function ContainerComponent() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.isContainer = true;
        _this.isFluidContainer = false;
        return _this;
    }
    /**
     * @return {?}
     */
    ContainerComponent.prototype.ngOnInit = /**
     * @return {?}
     */
    function () {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                if (this.uiModel.itemProperties.fullWidth) {
                    this.isFluidContainer = true;
                    this.isContainer = false;
                }
                return [2 /*return*/];
            });
        });
    };
    ContainerComponent.decorators = [
        { type: Component, args: [{
                    selector: 'dc-container',
                    template: "\n    <dc-container-row *ngFor=\"let item of uiModel.children\" [ngStyle]=\"getStyles(item.itemProperties)\"\n      (changedDataModel)=\"changedDataModel.emit($event)\"\n      [uiModel]='item'\n      [dataModel]='dataModel'\n      [workflowEngine]='workflowEngine'\n    ></dc-container-row>\n  ",
                    styles: ["\n    :host {\n      display: block;\n    }\n  "]
                }] }
    ];
    ContainerComponent.propDecorators = {
        isContainer: [{ type: HostBinding, args: ['class.container',] }],
        isFluidContainer: [{ type: HostBinding, args: ['class.container-fluid',] }]
    };
    return ContainerComponent;
}(BaseUIComponent));
var BSContainerProperties = /** @class */ (function (_super) {
    __extends(BSContainerProperties, _super);
    function BSContainerProperties() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    __decorate([
        propDescription({
            description: 'Is full width container, default false',
            example: 'true',
        }),
        __metadata("design:type", Boolean)
    ], BSContainerProperties.prototype, "fullWidth", void 0);
    return BSContainerProperties;
}(ContainerProperties));
/** @type {?} */
var example = {
    title: 'Bootstrap container example',
    uiModel: {
        type: 'bootstrap:container',
        containerProperties: {
            width: '100%'
        },
        itemProperties: {
            width: '20%',
            padding: '10px'
        },
        children: [{
                type: 'bootstrap:bs-row',
                containerProperties: {},
                children: [{
                        type: 'material:text',
                        containerProperties: {
                            fxFlex: '1 1 auto'
                        },
                        itemProperties: {
                            text: 'Row 1 / Item 1',
                        }
                    }, {
                        type: 'material:text',
                        containerProperties: {
                            fxFlex: '1 1 auto'
                        },
                        itemProperties: {
                            text: 'Row 1 / Item 2',
                        }
                    }]
            }, {
                type: 'bootstrap:bs-row',
                containerProperties: {},
                children: [{
                        type: 'material:text',
                        containerProperties: {
                            fxFlex: '1 1 auto'
                        },
                        itemProperties: {
                            text: 'Row 2 / Item 1',
                        }
                    }, {
                        type: 'material:text',
                        containerProperties: {
                            fxFlex: '1 1 auto'
                        },
                        itemProperties: {
                            text: 'Row 2 / Item 2',
                        }
                    }]
            }]
    },
    dataModel: {}
};
/** @type {?} */
var containerDescriptor = {
    name: 'container',
    packageName: 'bootstrap',
    category: 'Layout',
    description: 'Bootstrap container',
    itemProperties: BSContainerProperties,
    component: ContainerComponent,
    example: example
};

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var ContainerRowComponent = /** @class */ (function (_super) {
    __extends(ContainerRowComponent, _super);
    function ContainerRowComponent() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.isRow = true;
        return _this;
    }
    ContainerRowComponent.decorators = [
        { type: Component, args: [{
                    selector: 'dc-container-row',
                    template: "\n    <div *ngFor=\"let item of uiModel.children\" class=\"col-sm p-4\">\n      <dc-ui-selector\n          (changedDataModel)=\"changedDataModel.emit($event)\"\n          [uiModel]='item'\n          [dataModel]='dataModel'\n          [workflowEngine]='workflowEngine'\n      ></dc-ui-selector>\n    </div>\n  "
                }] }
    ];
    ContainerRowComponent.propDecorators = {
        isRow: [{ type: HostBinding, args: ['class.row',] }]
    };
    return ContainerRowComponent;
}(BaseUIComponent));
var BSContainerRowProperties = /** @class */ (function (_super) {
    __extends(BSContainerRowProperties, _super);
    function BSContainerRowProperties() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    return BSContainerRowProperties;
}(ContainerProperties));
/** @type {?} */
var example$1 = {
    title: 'Bootstrap container row example',
    uiModel: {
        type: 'bootstrap:bs-row',
        containerProperties: {
            width: '100%'
        },
        itemProperties: {
            width: '50%',
            padding: '10px'
        },
        children: [{
                type: 'material:text',
                containerProperties: {
                    fxFlex: '1 1 auto'
                },
                itemProperties: {
                    text: 'Text line 1',
                }
            }, {
                type: 'material:text',
                containerProperties: {
                    fxFlex: '1 1 auto'
                },
                itemProperties: {
                    text: 'Text line 2',
                }
            }]
    },
    dataModel: {}
};
/** @type {?} */
var containerRowDescriptor = {
    name: 'bs-row',
    packageName: 'bootstrap',
    category: 'Layout',
    description: 'Bootstrap row container',
    itemProperties: BSContainerRowProperties,
    component: ContainerRowComponent,
    example: example$1
};

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/** @type {?} */
var COMPONENTS_LIST = [
    containerDescriptor,
    containerRowDescriptor
];
// Register components.
/**
 * @return {?}
 */
function registerComponents() {
    COMPONENTS_LIST.forEach((/**
     * @param {?} component
     * @return {?}
     */
    function (component) { return CoreService.registerComponent(component); }));
}
/**
 * @return {?}
 */
function getCategories() {
    /** @type {?} */
    var categories = COMPONENTS_LIST.reduce((/**
     * @param {?} map
     * @param {?} desc
     * @return {?}
     */
    function (map, desc) {
        map[desc.category] = map[desc.category] || [];
        map[desc.category].push(desc);
        return map;
    }), {});
    return Object.entries(categories).map((/**
     * @param {?} __0
     * @return {?}
     */
    function (_a) {
        var _b = __read(_a, 2), key = _b[0], val = _b[1];
        return {
            name: key,
            components: val
        };
    }));
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var BootstrapModule = /** @class */ (function () {
    function BootstrapModule() {
        setTheme('bs4');
        registerComponents();
    }
    BootstrapModule.decorators = [
        { type: NgModule, args: [{
                    declarations: [ContainerComponent, ContainerRowComponent],
                    imports: [
                        CoreModule,
                        CommonModule
                    ],
                    exports: [ContainerComponent, ContainerRowComponent],
                    entryComponents: [ContainerComponent, ContainerRowComponent]
                },] }
    ];
    /** @nocollapse */
    BootstrapModule.ctorParameters = function () { return []; };
    return BootstrapModule;
}());

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */

export { COMPONENTS_LIST, getCategories, BootstrapModule, BSContainerRowProperties as ɵe, ContainerRowComponent as ɵd, containerRowDescriptor as ɵf, BSContainerProperties as ɵb, ContainerComponent as ɵa, containerDescriptor as ɵc };

//# sourceMappingURL=ngx-dynamic-components-bootstrap.js.map